/* abook_ldap.c  --  address books implemented via LDAP lookups

         Copyright 1998 by Carnegie Mellon University
 
                       All Rights Reserved
 
  Permission to use, copy, modify, and distribute this software and its
  documentation for any purpose and without fee is hereby granted,
  provided that the above copyright notice appear in all copies and that
  both that copyright notice and this permission notice appear in
  supporting documentation, and that the name of CMU not be
  used in advertising or publicity pertaining to distribution of the
  software without specific, written prior permission.
 
  CMU DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
  ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
  CMU BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
  ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
  WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
  ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
  SOFTWARE.
 
 */

#include <ldap.h>
#include "abook.h"

typedef struct abook_ldap_state {
    LDAP *ld;
    int msgid;
    LDAPMessage *prevresult;
} abook_ldap_state;

extern abook_fielddata *
abook_ldap_fetch(char *alias, int *count);

extern int
abook_ldap_searchstart(abook_ldap_state **ldap_state, 
		       abook_fielddata *flist, int fcount);

extern char *
abook_ldap_search(abook_ldap_state *ldap_state);

extern void
abook_ldap_searchdone(abook_ldap_state *ldap_state);
